#!/usr/bin/env python

import sys
from random import seed
from netmodel import NetModel,NetData
import getopt
#Seed graph


def printUsage():
  print >> sys.stderr,"netcreator.py [options] [model_file]"
  print >> sys.stderr,"\t\t-i [no of iterations]"
  print >> sys.stderr,"\t\t-n [no of nodes] TO IMPLEMENT"
  print >> sys.stderr,"\t\t-e [no of edges] TO IMPLEMENT"
  print >> sys.stderr,"\t\t-s [network file] -- seed network which is base for growth"
  print >> sys.stderr,"\t\t-o [outer model file] -- outer model read from file"
  print >> sys.stderr,"\t\t-r [random seed] -- set particular random seed"
  print >> sys.stderr,"\t\tSee README for detail of model file format"
  sys.exit()

noIter= 0
noNodes= 0
noEdges= 0
seedNetwork= False
nargs= len(sys.argv)
seed()
outerModFile= False


try:
  opts, args = getopt.getopt(sys.argv[1:], "o:i:n:e:s:r:")
except getopt.GetoptError, err:
  print >> sys.stderr, "Unrecognised option",err
  printUsage()
  sys.exit()
netSeed=""
for o, a in opts:
  if o == '-i':
    noIter= int(a)
  elif o == '-n':
    noNodes= int(a)
  elif o == '-e':
    noEdges= int(a)
  elif o == '-s':
    netSeed= a
  elif o == '-r':
    seed(int(a))
  elif o == '-o':
    outerModFile= a
  else:
    print >> sys.stderr, "Unrecognised option",err
    printUsage()
    sys.exit()
if len(args) != 1:
  printUsage()
  sys.exit()
model= NetModel()
model.read(args[0])

if outerModFile:
  try:
    outerModPtr= open(outerModFile,'r')
  except:
    print >> sys.stderr,"Cannot open ",outerModFile,"to read"
    sys.exit()
net= NetData(model)
if netSeed != "":
  net.read(netSeed,model)
  newDict={}
  for i in xrange(0,net.nodeCount):
    newDict[i]=i
  net.nodes= newDict
if noIter + noEdges + noNodes <= 0 and not outerModFile:
  print >> sys.stderr, "Must specify edges nodes or number of iterations or outermod file"
  sys.exit()
if noIter > 0: 
  if noEdges > 0 or noNodes > 0:
    print >> sys.stderr,"Please specify either nodes/edges or iterations not both"
    sys.exit()
  model.performIter(net, noIter)
elif outerModFile:
  model.performIterOuterFile(net, outerModPtr)
  outerModPtr.close()
else:
  print >> sys.stderr,"Not yet implemented"
  sys.exit()
net.printOut()
