#!/usr/bin/env python

# Reads files of network information writes files of link and node additions
import sys, getopt
from netmodel import NetData


modelStep= 1


def printUsage():
  print >> sys.stderr, "reorder.py [options] [network file]"
  print >> sys.stderr, "\t\t Reorder a network into time order"
  print >> sys.stderr, "\t\t -d Drop disconnected links as they arrive"
  print >> sys.stderr, "\t\t -i Ignore links disconnected at end of network"
  print >> sys.stderr, "\t\t    (this tried to connect all links and prints and"
  print >> sys.stderr, "\t\t    error for disconnected ones)"
  print >> sys.stderr, "\t\t -s Force simple -- insist network is simple"
  sys.exit()

try:
  opts, args = getopt.getopt(sys.argv[1:], "dis")
except getopt.GetoptError, err:
  print >> sys.stderr, "Unrecognised option",err
  printUsage()
  sys.exit()
netModel=""
ignoreDis= False
dropDis= False
forceSimple= False
for o, a in opts:
  if o == '-i':
    ignoreDis= True
  elif o == '-d':
    dropDis= True
  elif o == '-s':
    forceSimple= True
  else:
    print >> sys.stderr, "Unrecognised option"
    printUsage()
    sys.exit()
if len(args) != 1:
  printUsage()
  sys.exit()

network= NetData()
network.read(args[0], False,dropDis, ignoreDis, forceSimple)
totEdges= len(network.edges)
invdict={}
for k in network.nodes.keys():
  invdict[network.nodes[k]]=k
for e in network.edges:
  print invdict[e[0]],invdict[e[1]],e[2]



